/*

	i815 TWeaker - i815 Chipset TWeaker - (C) BJOne 2001

	Based on INTEL 82815 GMCH DATASHEET (June 2000)
	Document Reference Number 290688-001

  Yes, that code is ugly, but hey ! it's not worse than
  a VB code no ?

*/


//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include <math.h>

#include "Unit1.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMForm *MForm;

#include"i815.h"
#include"i815dc.c"

int ADDR_save,DATA_save;

int iread(int reg)
{
  int r;

  asm {
    mov edx,CONF_ADDR
    mov eax,reg
    or  eax,CFGE
    out dx,eax
    mov edx,CONF_DATA
    in  eax,dx
    mov r,eax
  };

  return r;
}


void iwrite(int reg, int value)
{
  asm {
    mov edx,CONF_ADDR
    mov eax,reg
    or  eax,CFGE
    out dx,eax
    mov edx,CONF_DATA
    mov eax,value
    out dx,eax
  };
}

AnsiString PrintDimmConfig(int id)
{
  AnsiString info;

  if(!id)
  {
	  info=" Empty\n";
  	goto ety;
	}

	int i;
  bool fnd;
	i815dimm_config *de;

	fnd=false;

	de=i815DIMM_TABLE;

	i=(sizeof(i815DIMM_TABLE)/sizeof(i815dimm_config));

	do {

		if( de->rc == id )
		{
			if(fnd)
				info+=" ------------------------------------------------\n";

			fnd=true;

			info+=" "+AnsiString(de->capacity)+" MB, DRAM Tech: "+
            AnsiString(de->dt1);

			if( de->dt2 )
				info+="/"+AnsiString(de->dt2);

      info+=+" Mb\n";

			info+="  Front Side: "+
      AnsiString(de->fs_count)+" Devices, "+
            AnsiString(de->fs_c)+" Mb x "+
            AnsiString(de->fs_m)+
            "\n  Back Side: "+
            AnsiString(de->bs_count)+" Devices";

			if(de->bs_count)
				info+=", "+AnsiString(de->bs_c)+
              " Mb x "+AnsiString(de->bs_m);

			info+="\n  Row: "+AnsiString(de->row)+
            ", Bank: "+AnsiString(de->bank1);

			if(de->bank2)
				info+="/"+AnsiString(de->bank2);

			info+=" Column: "+AnsiString(de->col1);

			if(de->col2)
				info+="/"+AnsiString(de->col2);

			info+="\n";
		}

		de++;

	} while(--i);

	if(!fnd)
		info=" Unknown Register Code: "+AnsiString(id)+"\n";

	ety:;

  return info;
}


void Setbit(int reg,int bitvalue, bool state)
{
  int val;

  val=iread(reg) & ~bitvalue;

  if( state )
    val|=bitvalue;

  iwrite(reg,val);

  MForm->iRefresh();
}

void __fastcall TMForm::iRefresh(void)
{
  int agpctrl,agpcmd,smram,sm,gmchcfg;

  agpctrl=iread(_AGPCTRL);
  agpcmd=iread(_AGPCMD);
  smram=iread(_SMRAM);
  sm=iread(_SM);
  gmchcfg=iread(_GMCHCFG);

  HACQScb->Checked=gmchcfg&HACQS;
  CLTcb->Checked=gmchcfg&CLT_SET;
  DPCPcombo->ItemIndex=(gmchcfg&DPCP_ALL)==DPCP_ALL;
  MAGcombo->ItemIndex=(gmchcfg&MAGWE_TS)==MAGWE_TS;

  AGP4XOVRcb->Checked=agpctrl&1;

  AGPSBAcb->Checked=agpcmd&SBA;

  AGPFWcb->Checked=agpcmd&FW;

  switch(agpcmd&7)
  {
    case 0:  AGPMODEcombo->ItemIndex=0;break;
    case 1:  AGPMODEcombo->ItemIndex=1;break;
    case 2:  AGPMODEcombo->ItemIndex=2;break;
    case 4:  AGPMODEcombo->ItemIndex=3;break;
    default:
    Application->MessageBox("AGP mode is set to an illegal value.",NULL,NULL);
  }

  BNRcb->Checked=smram&BNR;
  CPCcb->Checked=smram&CPC;
  SMcb->Checked=smram&SM;

  THRLOCKcb->Checked=smram&TLOCK;

/*
  RDTHRcombo->Enabled=!smram&TLOCK;
  WRTHRcombo->Enabled=!smram&TLOCK;
*/

  RDTHRcombo->ItemIndex=(smram>>(16+6))&3;
  WRTHRcombo->ItemIndex=(smram>>(16+4))&3;

  TDLLEcb->Checked=sm&TDLLE;

  CASgr->ItemIndex=(gmchcfg&CAS_2)==CAS_2;
  RAS2CASgr->ItemIndex=(gmchcfg&RAS2CAS_2)==RAS2CAS_2;
  RASgr->ItemIndex=(gmchcfg&RAS_2)==RAS_2;
  DCTgr->ItemIndex=(gmchcfg&DCT_79)==DCT_79;
  SMScombo->ItemIndex=(gmchcfg>>(5+24))&7;

  int data;

  data=iread(_AMTT)&0xFF;

  AMTT->Position=data;
  AMTTv->Caption=data;

  data=(iread(_AMTT)>>8)&0xFF;

  LPTT->Position=data;
  LPTTv->Caption=data;
}


//---------------------------------------------------------------------------
__fastcall TMForm::TMForm(TComponent* Owner)
  : TForm(Owner)
{
  asm {
    mov edx,CONF_ADDR
    in eax,dx
    mov ADDR_save,eax

    mov dx,CONF_DATA
    in eax,dx
    mov DATA_save,eax
  };

  if(iread(0)!=i815_ID)
  {
    Application->MessageBoxA("Not an i815 Chipset.",NULL,NULL);
    Application->Terminate();
  }



  RevLbl->Caption= RevLbl->Caption+AnsiString(iread(_RID)&0xFF);

  int gmchcfg;

  gmchcfg=iread(_GMCHCFG);

  if( gmchcfg & GFX_MODE )
  {
    Rmode->Caption="GFX mode";

    Application->MessageBox(
        "Warning: your i815 chipset is running in GFX mode.\n"
        "(The chipset uses its internal graphic device)\n"
        "Some tweaks may work unreliably !!!\n",NULL,NULL);
  }
  else
  {
    if( iread(_AMTT) & AGP_33V )
    {
       Rmode->Caption="AGP mode 3.3V";
       AGP4XOVRcb->Enabled=false;
    }
    else
       Rmode->Caption="AGP mode 1.5V";
  }

  if( gmchcfg&SMFS_133 )
    SMFSLbl->Caption="133 Mhz Operation";
  else
    SMFSLbl->Caption="100 Mhz Operation";

  RefreshBar->Hint=
    "i815 configuration rescan period.\n"
    "May be used for diagnostics.";

  Rmode->Hint=
    "Current i815 working mode.\n"
    "GFX mode is when i815 work with is own internal graphic\n"
    "adapter.\n"
    "AGP mode is when it is working with an external graphic\n"
    "adapter plugged in the AGP slot.\n"
    "3.3V / 1.5V is the signalling level of AGP transactions.\n"
    "Note that AGP 4X is only available with 1.5V signalling.";

  RevLbl->Hint=
   "This is the revision of your i815 Chipset.\n"
   "Value 2 means stepping A-2.";

  CLTcb->Hint=
    "From Intel:\n"
    "Disabled = Deferrable processor cycle will be Deferred immediately\n"
    "after receiving another ADS#\n\n"
    "Enabled  = Deferrable processor cycle will only be Deferred after\n"
    "in has been held in a Snoop Stall for 31 clocks and another ADS#\n"
    "has arrived.\n\n"
    "Let's say that enabled is better.";

  CPCcb->Hint="If you have your FSB overclocked more than 133Mhz,\n"
              "setting it like at 133 Mhz may introduce a performance increase.\n"
              "(I suppose that BIOS enables it to stabilize the system)";

  AGP4XOVRcb->Hint=
    "i815 AGP 4X works only with 1.5V signalling,\n"
    "AGP 2X & AGP 1X work in both 1.5V & 3.3V signalling.\n"
    "Make sure your video card/motherboard combo can work\n"
    "reliably in AGPX 4X with 1.5V signalling.";

  THRLOCKcb->Hint=
    "When throttle lock is enabled, read & write power throttle\n"
    "can't be modified.\n"
    "Yes, when it is enabled, you can't disable it anymore ;)";

  SMcb->Hint=
    "\"Should be enabled to optmize system memory by 1 clock for 133 Mhz\n"
    "operation (has no affect on 100 Mhz operation).\"\n"
    "Quoted from Intel datasheet ;)\n"
    "So do it.";

  TDLLEcb->Hint=
    "Controls offset of transmit & receive clocks used to interface\n"
    "with SDRAM devices.\n"
    "READ Intel's i815 datasheet before modifying this setting.\n"
    "YOUR SYSTEM MAY (SURELY) HANG IF YOU TOGGLE THIS !\n"
    "Come on boy, give it a try.";

  AGPFWcb->Hint=
    "WARNING: i815 doesn't support Fastwrites.\n"
    "YOUR SYSTEM WILL HANG !!\n"
    "( But since intel let it be programmable, you can try it ;)";

  CASgr->Hint=
    "SM register lower 16 bits seem to be modified when changing CAS setting.\n"
    "Since Intel marked these bits RESERVED, i don't know how to configure them.\n\n"
    "YOUR SYSTEM MAY HANG IF YOU TOGGLE CAS SETTING,\n"
    "ALTHOUGH IF IT SHOULD WORK FINE WITH THE NEW SETTING.\n\n"
    "(I will perhaps store SM state in a table to help switching properly.\n"
    "Perhaps that SM register lower word should be modified only when Transmit\n"
    "DLL is bypassed, because the story of the 8 programmable tap points that\n"
    "Intel talks about in i815 datasheet)";

  SMScombo->Hint=
    "WARNING: Some modes are intended for initialization at power-up.\n"
    "I think that every (!) mode shouldn't be selected.\n"
    "Lower refresh interval means better stability but lower\n"
    "memory bandwith.";

  HACQScb->Hint=
    "Intel recommands that i815ep bios enables HACQS.\n"
    "The bit involved in DRAMT register is marked as\n"
    "RESERVED in i815e datasheet.\n"
    "But my CUSL2 (not -C, so i815e based) set this bit !!!\n"
    "You know what you have to do know.";

  DPCPcombo->Hint=
    "Controls the Page Closing Policy, \"One Bank\" will tend\n"
    "to leave more pages open, so better system performance.\n"
    "BIOSs are likely to set it to \"All Banks\" when overclocking.";

  MAGcombo->Hint=
    "In timeslice mode host stream & low priority graphic\n"
		"stream are both regulated by a time window.\n"
		"Fixed mode, where the host stream is favored, is\n"
		"given to be the best setting.";

  FBLabel->Hint=
    "That's me !\n\n"
    "If you are thinking of some features that i should add or\n"
    "you think you have found a bug in my code, don't hesitate\n"
    "to email-me....\n"
    "Hey i'm french, so be cool with my hazardous english ;)";

  AboutRC->Text=
    "Welcome to i815 Tweaker.\n\n"
    "This tool was designed to enable intel i815 functions "
    "that can't be found in your motherboard BIOS.\n"
    "The i815 is an overclocking king, but for stability reasons, "
    "BIOSes disable some features.\n"
    "Most of them are AGP 4X & some memory optimizations.\n"
    "If you are overclocking your system and you want "
    "to optimize it, take a close look at what is set when running "
    "at your default FSB and try to apply the same settings when overclocked.\n\n"
    "This tweaker controls i815 chipset features, but doesn't modify "
    "cpu/vio voltage or any kind of dangerous stuff.\n\n"
    "The only thing that you should be aware of is that your system "
    "may immediately hang after a change, because changes are "
    "IMMEDIATLY applied (when you click).\n\n"
    "So don't forget to close applications that have documents opened, "
    "and wait a little (some seconds) so that disk cache data are written down.\n";

  AboutRC->Text=AboutRC->Text+"\n\nDIMM 0 Population:\n";
  AboutRC->Text=AboutRC->Text+PrintDimmConfig((gmchcfg>>16)&0xf);

  AboutRC->Text=AboutRC->Text+"\nDIMM 1 Population:\n";
  AboutRC->Text=AboutRC->Text+PrintDimmConfig((gmchcfg>>(16+4))&0xf);

  AboutRC->Text=AboutRC->Text+"\nDIMM 2 Population:\n";
  AboutRC->Text=AboutRC->Text+PrintDimmConfig(iread(_DRP2)&0xf);

  PageCtrl->ActivePage=AboutSheet;

  RefreshBar->Position=2000;
  RefreshBarChange(this);

  Application->HintHidePause=60000;

  iRefresh();
}
//---------------------------------------------------------------------------
void __fastcall TMForm::FormClose(TObject *Sender, TCloseAction &Action)
{
  asm {
    mov edx,CONF_ADDR
    mov eax,ADDR_save
    out dx,eax

    mov edx,CONF_DATA
    mov eax,DATA_save
    out dx,eax
  };
}
//---------------------------------------------------------------------------


void __fastcall TMForm::PageCtrlChange(TObject *Sender)
{
  iRefresh();
}
//---------------------------------------------------------------------------

void __fastcall TMForm::AGP4XOVRcbClick(TObject *Sender)
{
  Setbit(_AGPCTRL,1,AGP4XOVRcb->Checked);
}
//---------------------------------------------------------------------------

void __fastcall TMForm::AGPSBAcbClick(TObject *Sender)
{
  Setbit(_AGPCMD,SBA,AGPSBAcb->Checked);
}
//---------------------------------------------------------------------------

void __fastcall TMForm::AGPFWcbClick(TObject *Sender)
{
  Setbit(_AGPCMD,FW,AGPFWcb->Checked);
}
//---------------------------------------------------------------------------


void __fastcall TMForm::AGPMODEcomboChange(TObject *Sender)
{
  unsigned int val;

  val=iread(_AGPCMD) & ~7;

  if( AGPMODEcombo->ItemIndex < 3 )
    val|=AGPMODEcombo->ItemIndex;
  else
    val|=4;

  iwrite(_AGPCMD,val);

  iRefresh();
}
//---------------------------------------------------------------------------

void __fastcall TMForm::BNRcbClick(TObject *Sender)
{
  Setbit(_SMRAM,BNR,BNRcb->Checked);
}
//---------------------------------------------------------------------------

void __fastcall TMForm::CPCcbClick(TObject *Sender)
{
  Setbit(_SMRAM,CPC,CPCcb->Checked);
}
//---------------------------------------------------------------------------

void __fastcall TMForm::SMcbClick(TObject *Sender)
{
  Setbit(_SMRAM,SM,SMcb->Checked);
}
//---------------------------------------------------------------------------


void __fastcall TMForm::THRLOCKcbClick(TObject *Sender)
{
  Setbit(_SMRAM,TLOCK,THRLOCKcb->Checked);
}
//---------------------------------------------------------------------------

void __fastcall TMForm::TDLLEcbClick(TObject *Sender)
{
  Setbit(_SM,TDLLE,TDLLEcb->Checked);
}
//---------------------------------------------------------------------------

void __fastcall TMForm::RDTHRcomboChange(TObject *Sender)
{
  int val;

  val=iread(_SMRAM) & ~(3<<(16+6));
  val|=(RDTHRcombo->ItemIndex&3)<<(16+6);
  iwrite(_SMRAM,val);

  iRefresh();
}
//---------------------------------------------------------------------------

void __fastcall TMForm::WRTHRcomboChange(TObject *Sender)
{
  int val;

  val=iread(_SMRAM) & ~(3<<(16+4));
  val|=(WRTHRcombo->ItemIndex&3)<<(16+4);
  iwrite(_SMRAM,val);

  iRefresh();
}
//---------------------------------------------------------------------------

void __fastcall TMForm::HACQScbClick(TObject *Sender)
{
  Setbit(_GMCHCFG,HACQS,HACQScb->Checked);
}
//---------------------------------------------------------------------------


void __fastcall TMForm::AMTTChange(TObject *Sender)
{
  iwrite( _AMTT,(iread(_AMTT)&~0xFF) | AMTT->Position );

  iRefresh();
}
//---------------------------------------------------------------------------

void __fastcall TMForm::LPTTChange(TObject *Sender)
{
  iwrite( _AMTT,(iread(_AMTT)&~0xFF00) | (LPTT->Position<<8) );

  iRefresh();

}
//---------------------------------------------------------------------------

void __fastcall TMForm::iRefreshTmrTimer(TObject *Sender)
{
  iRefresh();
}
//---------------------------------------------------------------------------


void __fastcall TMForm::CASgrClick(TObject *Sender)
{
  Setbit(_GMCHCFG,CAS_2,CASgr->ItemIndex);
}
//---------------------------------------------------------------------------

void __fastcall TMForm::RAS2CASgrClick(TObject *Sender)
{
  Setbit(_GMCHCFG,RAS2CAS_2,RAS2CASgr->ItemIndex);
}
//---------------------------------------------------------------------------

void __fastcall TMForm::RASgrClick(TObject *Sender)
{
  Setbit(_GMCHCFG,RAS_2,RASgr->ItemIndex);
}
//---------------------------------------------------------------------------

void __fastcall TMForm::SMScomboChange(TObject *Sender)
{
  int val;

  val=iread(_GMCHCFG) & ~(7<<(5+24));
  val|=(SMScombo->ItemIndex&7)<<(5+24);
  iwrite(_GMCHCFG,val);
}
//---------------------------------------------------------------------------

void __fastcall TMForm::DCTgrClick(TObject *Sender)
{
  Setbit(_GMCHCFG,DCT_79,DCTgr->ItemIndex);
}
//---------------------------------------------------------------------------

void __fastcall TMForm::CLTcbClick(TObject *Sender)
{
  Setbit(_GMCHCFG,CLT_SET,CLTcb->Checked);
}
//---------------------------------------------------------------------------

void __fastcall TMForm::DPCPcomboChange(TObject *Sender)
{
  Setbit(_GMCHCFG,DPCP_ALL,DPCPcombo->ItemIndex);
}
//---------------------------------------------------------------------------

void __fastcall TMForm::RefreshBarChange(TObject *Sender)
{
  iRefreshTmr->Interval=RefreshBar->Position;

  RfLabel->Caption=AnsiString(RefreshBar->Position)+" ms";
}
//---------------------------------------------------------------------------



void __fastcall TMForm::MAGcomboChange(TObject *Sender)
{
  Setbit(_GMCHCFG,MAGWE_TS,MAGcombo->ItemIndex);
}
//---------------------------------------------------------------------------

